package fi.er.formPlugin;

import com.alibaba.nacos.common.utils.StringUtils;
import kd.bos.bill.BillShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.form.plugin.AbstractFormPlugin;

import java.util.EventObject;

public class ContratBillFormPlugin extends AbstractFormPlugin implements HyperLinkClickListener {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 监听分录行
        EntryGrid entryGrid = this.getView().getControl("nckd_payentry");
        entryGrid.addHyperClickListener(this);
    }
    @Override
    public void hyperLinkClick(HyperLinkClickEvent hyperLinkClickEvent) {
        //  获取超链接点击的属性名
        String fieldName = hyperLinkClickEvent.getFieldName();
        //  获取点击分录行的下标
        int rowIndex = hyperLinkClickEvent.getRowIndex();
        if (StringUtils.containsIgnoreCase(fieldName,"nckd_pay_billno1")){
            //付款处理id
            Object id = this.getModel().getValue("nckd_pay_id1", rowIndex);

            BillShowParameter billShowParameter = new BillShowParameter();
            // 设置打开单据的标识
            billShowParameter.setFormId("cas_paybill");
            // 设置打开单据的id
            billShowParameter.setPkId(id);
            // 设置打开的样式
            billShowParameter.getOpenStyle().setShowType(ShowType.Modal);

            this.getView().showForm(billShowParameter);
        }
    }

}
